#pragma once
#define  _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>
#include <math.h>
#include <time.h>

#include <windows.h>

#include <cassert>
#include <cstdint>
#include <cstdio>
#include <iostream>
#include <fstream>
#include <algorithm>
#include "cnn.h"


typedef struct
{
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;
} rgb_t;

uint32_t byteswap_uint32(uint32_t a);

char *get_file(char *filename, unsigned int *size);
int train(std::vector<layer_t*> &layers);
int test(std::vector<layer_t*> &layers, uint8_t * data, float *results);

#define NUMBER_OF_OUTPUT_CELLS 47
#define MNIST_IMG_WIDTH 28                                  // image width in pixel
#define MNIST_IMG_HEIGHT 28                                 // image height in pixel
#define MAX_TRAIN_IMAGE 112800


void rotate_right(int width, int height, unsigned int *input, unsigned int *output);
void transpose(int width, int height, unsigned int *input, unsigned int *output);
void rotate_right(int width, int height, unsigned char *input, unsigned char *output);
void transpose(int width, int height, unsigned char *input, unsigned char *output);